using System;
using System.Runtime.CompilerServices;

class A { 
    public A(TestSync2 test) { 
        this.test = test; 
    }
    //    [MethodImpl(MethodImplOptions.Synchronized)]
    public void foo() {
        lock(this) {
            test.g();
        }
    }
    TestSync2 test;
}

class B { 
    public B(TestSync2 test) { 
        this.test = test; 
    }
    public void foo() {
        lock(this) {
            test.f();       
        }
    }
    TestSync2 test;
}

public class TestSync2 { 
    public void f() { 
        a.foo();
    }

    public void g() { 
        b.foo();
    }

    public void Run()
    {
        if (x) { 
            f();
        } else { 
            g();
        }
    }

    public static void Main(String[] args) {
        TestSync2 test = new TestSync2();
        test.Start();
    }

    void Start() {
        System.Threading.Thread thread = new System.Threading.Thread(new System.Threading.ThreadStart(Run));
        t = typeof(TestSync2);
        thread.Start();
    }

    TestSync2() { 
        x = true;
        a = new A(this);
        b = new B(this);
    }

    bool x;
    A    a;
    B    b;  
    Type t;    
}


